'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _AbstractExecution = require('./AbstractExecution');

var _AbstractExecution2 = _interopRequireDefault(_AbstractExecution);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *
 *
 * @extends AbstractExecution
 */
class SerialBatch extends _AbstractExecution2.default {
  /**
   * @inheritDoc
   */
  execute(...args) {
    const zeroStage = Promise.resolve([]);

    return this._jobs.reduce((lastStage, currentStage) => lastStage.then(results => this._executeJob(currentStage, args).then(Array.prototype.concat.bind(results))), zeroStage);
  }

  _executeJob(stage, args) {
    let result = stage(...args);

    if (!(result instanceof Promise)) {
      result = Promise.resolve(result);
    }

    return result;
  }
}
exports.default = SerialBatch;

typeof $IMA !== 'undefined' && $IMA !== null && $IMA.Loader && $IMA.Loader.register('ima/execution/SerialBatch', [], function (_export, _context) {
 'use strict';
 return {
   setters: [],
   execute: function () {
     _export('default', exports.default);
   }
 };
});
